#version 430

in vec3 position;
in vec3 normal;
in float boneWeight[11];

out VS_OUT {
    vec3 FragPos;
    vec3 Normal;
} vs_out;

uniform mat4 projection;
uniform mat4 view;
uniform mat4 model;
uniform mat4 boneTransforms[11];
uniform mat4 boneOffsets[11];

void main(){
	mat4 boneTransformation = boneWeight[0] * boneTransforms[0];
	for(int i = 1; i < 11; i++) {
		if (boneWeight[i] > 0) {
			boneTransformation += boneWeight[i] * (boneTransforms[i]);
		}
	}
	vec4 basicPosition = boneTransformation * vec4(position, 1.0f);
	gl_Position = projection * view * model * basicPosition;
    vs_out.FragPos = vec3(model * basicPosition);   
        
    mat4 normalMatrix = transpose(inverse(model));
    vs_out.Normal = (boneTransformation * normalize(normalMatrix * vec4(normal, 1))).xyz;
}